#if defined(__STDC__) || defined( _PROTOTYPES)

extern void PS_dynam ( struct pst_dynamic * );
extern void PS_stat  ( struct pst_static * );
extern void PS_vm    ( struct pst_vminfo * );
extern int  PS_proc  ( struct pst_status *, int, int );

extern void set_users(); 
extern char *get_user( int );
extern long get_user_id( char * );
extern void user_info ( void );
extern void get_user_sum( int, long *, long *, long *);

extern void setup_tty( void );
extern char *get_tty( long, long );

extern int compare_start_time(struct pst_status *, struct pst_status *);
extern char *visual_start_time( int );

extern int compare_user_time(struct pst_status *, struct pst_status *);
extern char *visual_user_time( int );

/* HV */
extern int compare_sched_time(struct pst_status *, struct pst_status *);

extern int compare_ressize( struct pst_status *, struct pst_status *);
extern int compare_size( struct pst_status *, struct pst_status *);

extern void Print_Conf( int, struct pst_dynamic *);
extern void Print_Who ( int );

extern char *get_dimension( long );

extern void mpreprocess( int, char *[],  char * );
extern void Print_vm( void );
extern void Print_who( int );
extern char *info_cpu( long * );

extern char get_status( int );
extern void count_status( int );
extern int status_sleep( void ), status_run( void );
extern int status_stop( void ), status_other( void );
extern int status_zombie( void );
extern void examine_utmp ( void );

extern int reg_match ( char * );
extern void reg_set ( char * );

#ifndef NO_CURSES
extern void quit ( int ), init_curses ( void ), clear_screen ( void );
extern int look_lines ( void ), look_cols ( void );
extern int curses_wait ( int );
extern void update_first_line ( int, struct pst_dynamic * );
extern void curses_refresh ( void ), curses_error (  char * );
extern long ask_curses ( char * );
extern void curses_in_reverse ( void ), curses_out_reverse ( void );
extern void curses_print_help ( void ), refresh_all ( void );
extern char *curses_get_string ( char * );

	/* On other files only this routine is needed */
extern int printw( const char *, ...); 
extern void renice( int, int );

#else /* NO_CURSES */
extern long ask_curses( char * );  /* Empty file if NO_CURSES */
extern int look_lines( void ), look_cols( void );
extern char *curses_get_string ( char * );
#endif /* NO_CURSES */


#else  /* Not __STDC__ */

extern void PS_dynam ();
extern void PS_stat  ();
extern void PS_vm    ();
extern int  PS_proc  ();

extern void set_users(); 
extern char *get_user();
extern long get_user_id();
extern void user_info ();
extern void get_user_sum();

extern void setup_tty();
extern char *get_tty();

extern int compare_start_time();
extern char *visual_start_time();

extern int compare_user_time();
extern char *visual_user_time();

/* HV */
extern int compare_sched_time();

extern int compare_ressize();
extern int compare_size();

extern void Print_Conf();
extern void Print_Who ();

extern char *get_dimension();

extern void mpreprocess();
extern void Print_vm();
extern void Print_who();
extern char *info_cpu();

extern char get_status();
extern void count_status();
extern int status_sleep(), status_run(),status_stop(),status_other();
extern int status_zombie();
extern void examine_utmp();

extern int reg_match ();
extern void reg_set ();

#ifndef NO_CURSES
extern void init_curses(),update_first_line(),curses_refresh();
extern void curses_error(), curses_print_help(), clear_screen();
extern int look_lines(), look_cols(), curses_wait();
extern void curses_in_reverse(), curses_out_reverse(), quit();
extern void refresh_all();
extern long ask_curses();
extern char *curses_get_string();

/* On other files only this routine is needed */
extern int printw();

extern void renice();
#else 

/* Empty file if NO_CURSES */
extern long ask_curses();
extern int look_lines(), look_cols();
extern char *curses_get_string();
#endif
#endif /* __STDC_ */


/* Global variable */

extern struct pst_status pbuf[];
extern int invert, wait_second, sstring;
extern int system_time_include, user_time_include;
extern int allow_root, long_format, print_configuration;
extern int vm_config, wcpu, who, reverse, reverse_index;
extern long look_process, look_uid;
extern int Num_display_proc, set_euid;
extern int (*order)();
extern int displayed, pages, look_utmp;
