#include <signal.h>
#include "define.h"
#include "extern.h"

       /* If you want disable "P" and "K" comment out this lines */
#ifndef SU_COMMAND
#define SU_COMMAND "su"
#endif

#ifndef SU_KILLUSER
#define SU_KILLUSER 9
#endif

#ifndef SU_KILLPROCESS
#define SU_KILLPROCESS 9
#endif

void mpreprocess( ac, av, cmd_line )
int ac;
char *av[], *cmd_line;
{
	int car;
	extern char *optarg;
	extern long atol();

	if ( !av ) {
		car = ac; 
		goto jump;  /* :-) */
	}
	
	while ( ( car = getopt ( ac, av, cmd_line ) ) != EOF )

jump:
	switch ( car ) {
		case 'm':
			if ( look_uid == -1L )
				look_uid = getuid();
			else
				look_uid = -1L;
			pages = 0;
			who = 0;
			reverse = 0;
			reverse_index = -1;
			look_utmp = 0;
		break;
		case 'C':
			print_configuration = 1;
			who = 0;
			look_utmp = 0;
			reverse = 0;
			reverse_index = -1;
			look_process = -1;
		break;
		case 'V':
			vm_config = 1;
			who = 0;
			look_utmp = 0;
			reverse = 0;
			reverse_index = -1;
			look_process = -1;
			print_configuration = 0;
		break;
		case '%':
			if ( look_cols() < 90 )
				wcpu = !wcpu;
		break;
		case 'e':
			who = 0;
			look_utmp = !look_utmp;
		break;
#ifdef NO_CURSES
		case 'L':
			long_format = 1;
		break;
#endif
#ifndef NO_CURSES
		case ' ':
		case '\n':
			look_process = -1L;
			pages = print_configuration = vm_config = who = look_utmp =0;
			Num_display_proc = look_lines() - 6;
			reverse = 0;
			reverse_index = -1;

			if ( car == ' ' )  {
				order = NULL;
				look_uid = -1;
				if ( sstring ) {
					reg_set ( NULL );
					sstring = 0;
				}
			}

		break;
		case 'j':
			if ( displayed && reverse <= displayed )
				reverse++;

			if ( displayed && reverse > displayed  ) {
				reverse = 0;
				reverse_index = -1;
			}
		break;
		case 'k':
			if ( displayed && reverse == 0 )
				reverse = displayed + 1;   /* Next instruct decrement reverse */

			if ( displayed && reverse > 0 )
				reverse--;

			if ( displayed && reverse == 0 )
				reverse_index = -1;
		break;
		case 'f':
			if ( displayed )
				pages++;
			reverse = 0;
			reverse_index = -1;
		break;
		case 'b':
			if ( --pages < 0 )
				pages = 0;
			reverse = 0;
			reverse_index = -1;
		break;
		case 'B':
			pages = 0;
			reverse = 0;
			reverse_index = -1;
		break;
		case 'I':
			if ( reverse ) 
				look_uid = pbuf [ reverse_index ].pst_uid;

			if ( look_uid != -1L )
				user_info();

			reverse = 0;
			reverse_index = -1;
		break;

#if defined (SU_COMMAND) && (SU_KILLPROCESS)
		case 'P':
		{
			char buf[ 128 ], *user;
			long ret, pid;

			if ( !reverse )
				break;

			pid = pbuf [ reverse_index ].pst_pid;
			user = get_user ( reverse_index );

			sprintf ( buf, "kill proc %ld (%s) ? ( type 0 to confirm ): ", pid, user );
			ret = ask_curses ( buf );

			if ( ret )
				break;

			sprintf ( buf, "%s %s -c \"kill -%d %ld\"",
				SU_COMMAND, user, SU_KILLPROCESS , pid );

			if ( kill ( pid, SU_KILLPROCESS ) == -1 )
				system ( buf );

			refresh_all();
			}
		break;
#endif
#if defined (SU_COMMAND) && (SU_KILLUSER)
		case 'K':
			{
			char buf[ 128 ], *user;
			long ret;

			if ( !reverse )
				break;

			user = get_user ( reverse_index );
			sprintf ( buf, "kill user %s ? ( type 0 to confirm ): ", user );
			ret = ask_curses ( buf );
			if ( ret )
				break;

			sprintf ( buf, "%s %s -c \"kill -%d -1\"",
				SU_COMMAND, user, SU_KILLUSER );

			system ( buf ); 
			refresh_all();
			}
		break;
#endif
		case 'R':
		{
			char buf [ 128 ];
			if ( reverse ) {
				look_process = pbuf [ reverse_index ].pst_pid;
				sprintf ( buf, "User %s (%ld). Type New priority: ",
					get_user ( reverse_index ) ,
					look_process );
			}
			else {
				look_process = ask_curses ( "Type Process number: " );
				sprintf ( buf, "Process %ld. Type New priority: ",
					look_process );
			}

				
			renice ( ( int )look_process, ( int )ask_curses ( buf ));
			
			look_process = -1L;
		}
		break;
#endif
		case 'p':

			if ( reverse ) 
				look_process = pbuf [ reverse_index ].pst_pid;

			else

				if ( av )
					look_process = atol ( optarg );
				else
					look_process = ask_curses ( "Type Process number: " );
			who = 0;
			look_utmp = 0;
			reverse = 0;
			reverse_index = -1;
		break;
		case 'E':
			set_euid = !set_euid;
			pages = 0;
			reverse = 0;
			reverse_index = -1;
		break;
		case 'w':
			who = !who;
			pages = 0;
			reverse = 0;
			reverse_index = -1;
		break;
		case 'W':
			if ( av )
				wait_second = atoi ( optarg );
			else
				wait_second = ( int )ask_curses ( "Type seconds: " );

			if ( wait_second < 0 )
				wait_second *= -1;
		break;
		case '/':
			if ( av ) {
				reg_set ( optarg );
				sstring = 1;
			}
			else {
				char *search = curses_get_string ( "Type string to search: " );
				if ( search ) {
					reg_set ( search );
					sstring = 1;
				}
				else {
					sstring = 0;
					reg_set ( NULL );
				}
			}
		break;
		case 'N':
			if ( av )
				Num_display_proc = atoi ( optarg ); 
			else {
				int lines = look_lines ();
				Num_display_proc =
					( int )ask_curses ( "Type number of processes: " );
				if ( Num_display_proc > lines - 6 || Num_display_proc < 0 )
					Num_display_proc = lines - 6;
			}
			pages = 0;
			reverse = 0;
			reverse_index = -1;
		break;
		case 'i':
			invert = !invert;
		break;
		case 's':
			order = compare_start_time;
		break;
		case 'd':
			order = compare_size;
		break;
		case 'D':
			order = compare_ressize;
		break;
		case 't':
			order = compare_user_time;
		break;
		case 'c':
			order = compare_sched_time; /* added by HV */
		break;
		case 'S':
			system_time_include = 1;
			user_time_include = !user_time_include;
		break;
		case 'U':
			user_time_include = 1;
			system_time_include = !system_time_include;
		break;
		case 'u':

			if ( reverse ) 
				look_uid = pbuf [ reverse_index ].pst_uid;

			else

				if ( av )
					if ( *optarg < '0' || *optarg > '9' )
						look_uid = get_user_id ( optarg );
					else
						look_uid = atol ( optarg );
				else {
					char *u_name = curses_get_string ( "Type uid or name ( <RET> for previous state ): " );

					if ( !u_name )
						look_uid = -1L;
					else
						if ( *u_name < '0' || *u_name > '9' ) 
							look_uid = get_user_id ( u_name );
						else
							look_uid = atol ( u_name );
				}

			if ( look_uid == 0L )   /* look for root */
				allow_root =1;

			pages = 0;
			who = 0;
			look_utmp = 0;
			reverse = 0;
			reverse_index = -1;
		break;
		case 'r':
			allow_root = !allow_root;
			pages = 0;
			reverse = 0;
			reverse_index = -1;
		break;
		default:
			if ( !av )
				return;

			puts ( "-m          -  Display only 'm'y processes.");
			puts ( "-s          -  Sort by 's'tart time." );
			puts ( "-t          -  Sort by process 't'ime."  );
			puts ( "-c          -  Sort by process %cpu time, default." ); /* HV */
			puts ( "-d          -  Sort by process size ( data + text + stack ).");
			puts ( "-D          -  Sort by process resident set size.");
			puts ( "-E          -  Show processes with uid != euid.");
			puts ( "-r          -  Allow display of 'r'oot process." );
			puts ( "-%          -  Switch between  STIME and WCPU fields." );
			puts ( "-u uid|name -  Restrict to a specific 'U'ser." );
#ifdef NO_CURSES
			puts ( "-L          -  Display long format of command name." );
#endif
			puts ( "-i          -  Invert sorting order." );
			puts ( "-e          -  Display the entries in utmp." );
			puts ( "-S          -  Display only System time to field \"TIME\" that normally is system_time + user_time.");
			puts ( "-U          -  Display only User time to field \"TIME\".");
			puts ( "-p process  -  Analyze a single process" );
			puts ( "-C          -  Display configuration of machine." );
			puts ( "-V          -  Virtual memory info." );
			puts ( "-w          -  Like who." );
			puts ( "-N number   -  Display only \"number\" process." );
			puts ( "-/ string   -  Search string in command line.");
			puts ( "-W second   -  Loop forever waiting \"second\" for each loop ( type DELETE or QUIT to exit." );
			exit ( 1 );
		break;
	}
}
