#include "define.h"
#include "extern.h"

void Print_vm()
{
	struct pst_vminfo vbuf;

#ifndef NO_CURSES
	if ( look_lines() < 24 ) {
		curses_error( "Sorry, you must have at least 24 lines." );
		vm_config = 0;
		return;
	}
#define PF (void)printw	
#else
#define PF (void)printf
#endif

	PS_vm ( &vbuf );

	PF ( "\n-----------------------------  SUM  ---------  RATIO\n");

	PF ( "Calls to syscall():   %12ld   |  %12ld\n",
		vbuf.psv_ssyscall, vbuf.psv_rsyscall );
	PF ( "Pages paged in:       %12ld   |  %12ld\n",
		vbuf.psv_spgpgin, vbuf.psv_rpgpgin );
	PF ( "Pages paged out:      %12ld   |  %12ld\n",
		vbuf.psv_spgpgout, vbuf.psv_rpgpgout );
	PF ( "Context switches:     %12ld   |  %12ld\n",
		vbuf.psv_sswtch, vbuf.psv_rswtch );
	PF ( "Device interrupts:    %12ld   |  %12ld\n",
		vbuf.psv_sintr, vbuf.psv_rintr );
	PF ( "\n-----------------------------  SUM  -----------------\n" );

	PF ( "Swapins:              %12ld\n", vbuf.psv_sswpin );
	PF ( "Swapouts:             %12ld\n", vbuf.psv_sswpout );
	PF ( "Number of forks:      %12ld\n", vbuf.psv_cntfork );
	PF ( "Pageins:              %12ld\n", vbuf.psv_spgin );
	PF ( "Pageouts:             %12ld\n" , vbuf.psv_spgout );
	PF ( "Pages swapped in:     %12ld\n", vbuf.psv_spswpin );
	PF ( "Pages swapped out:    %12ld\n", vbuf.psv_spswpout );
	PF ( "Total page reclaims:  %12ld\n", vbuf.psv_spgrec );
	PF ( "Calls to trap:        %12ld\n", vbuf.psv_strap );
	PF ( "Free memory pages:    %12ld  ( %s )\n", vbuf.psv_cfree, get_dimension ( vbuf.psv_cfree) );
}
